

#property indicator_chart_window

extern int    NumberOfDays = 100; 
extern string time1     = "08:00";   
extern string time2       = "23:59";
extern string time3       = "00:00";



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init()
 {

        

}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit()
 {


    int ObjectCount = ObjectsTotal();
   for (int i=ObjectCount-1; i>=0; i--)
   {
      if(StringFind(ObjectName(i),"Sad") != -1)
      {
         ObjectDelete(ObjectName(i));
      }  
   }
//----
   return(0);

}

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() 
{

  datetime dt=CurTime();
  

  for (int i=0; i<NumberOfDays; i++)

     {
    DrawObjects(dt, "Sad"+i, time1, time2,time3);
    dt=decDateTradeDay(dt);
    while (TimeDayOfWeek(dt)>5) dt=decDateTradeDay(dt);
  }
     
}

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void DrawObjects(datetime dt, string no, string tb, string te, string tz)

 {
  datetime t1, t2 ,t3 ;
  double   p1, p2,p3;
  int      b1, b2,i,b3;

   
  
   
   
   //...........................................................
  t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
  t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
  t3=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tz);

  //+------------------------------------------------------------------+           

  
//+------------------------------------------------------------------+
  
  b1=iBarShift(NULL, 0, t1);
  b2=iBarShift(NULL, 0, t2);
  b3=iBarShift(NULL, 0, t3);
  
  p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2, b2)];
  p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2, b2)];
  

p3=Open[b3]; //00:00


//+------------------------------------------------------------------+

//+------------------------------------------------------------------+ 
   ObjectCreate(no+"HLine",OBJ_TREND,0,0,0,0);
  
          ObjectSet(no+"HLine",OBJPROP_RAY,false);
          ObjectSet(no+"HLine",OBJPROP_WIDTH,3);
          ObjectSet(no+"HLine",OBJPROP_COLOR,Blue);
          ObjectSet(no+"HLine",OBJPROP_PRICE1,p1 );
          ObjectSet(no+"HLine",OBJPROP_PRICE2,p1 );
          ObjectSet(no+"HLine",OBJPROP_TIME1,t1);
          ObjectSet(no+"HLine",OBJPROP_TIME2,t2);
          




//+------------------------------------------------------------------+
//+------------------------------------------------------------------+ 
   ObjectCreate(no+"LLine",OBJ_TREND,0,0,0,0);
  
          ObjectSet(no+"LLine",OBJPROP_RAY,false);
          ObjectSet(no+"LLine",OBJPROP_WIDTH,3);
          ObjectSet(no+"LLine",OBJPROP_COLOR,Red);
          ObjectSet(no+"LLine",OBJPROP_PRICE1,p2 );
          ObjectSet(no+"LLine",OBJPROP_PRICE2,p2 );
          ObjectSet(no+"LLine",OBJPROP_TIME1,t1);
          ObjectSet(no+"LLine",OBJPROP_TIME2,t2);
          


//+------------------------------------------------------------------+
//+------------------------------------------------------------------+ 
   ObjectCreate(no+"OLine",OBJ_TREND,0,0,0,0);
  
          ObjectSet(no+"OLine",OBJPROP_RAY,false);
          ObjectSet(no+"OLine",OBJPROP_WIDTH,3);
          ObjectSet(no+"OLine",OBJPROP_COLOR,White);
          ObjectSet(no+"OLine",OBJPROP_PRICE1,p3 );
          ObjectSet(no+"OLine",OBJPROP_PRICE2,p3 );
          ObjectSet(no+"OLine",OBJPROP_TIME1,t3);
          ObjectSet(no+"OLine",OBJPROP_TIME2,t2);
          



}

//----
   return(0);


datetime decDateTradeDay (datetime dt)
 {
  int ty=TimeYear(dt);
  int tm=TimeMonth(dt);
  int td=TimeDay(dt);
  int th=TimeHour(dt);
  int ti=TimeMinute(dt);

  td--;
  if (td==0)
   {
    tm--;
    if (tm==0)
     {
      ty--;
      tm=12;
    }
    if (tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
    if (tm==2) if (MathMod(ty, 4)==0) td=29; else td=28;
    if (tm==4 || tm==6 || tm==9 || tm==11) td=30;
  }
  return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}
//+------------------------------------------------------------------+

